/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.cvut.ds.dsjdbc;

import cz.cvut.ds.dsjdbc.entities.*;
import java.util.List;

/**
 *
 * @author marek
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        try {
            for (Department d : Storage.getInstance().getAllDepartments()) {
                System.out.println("department: "+d.getDepartmentDescription());
                List<Employee> emps = Storage.getInstance().getEmployeesByDepartment(d);
                if (emps.isEmpty()) {System.out.println(" which has no employees");}
                else {System.out.println(" which has "+emps.size()+" employees, e.g.: "+emps.get(0).getFullName());}
                double totalPaidSalaries = 0;
                for (Employee emp : emps) {
                    for (Salary s : Storage.getInstance().getSalariesByEmployee(emp)) {
                        totalPaidSalaries += s.getSalaryPaid();
                    }
                }
                System.out.println(" with total paid salaries: "+String.format("%.2f", totalPaidSalaries));
                /*
                 * POZOR - velmi neefektivni.
                 * V podstate vytahne tyto 3 tabulky z databaze kompletne, i kdyz vypisujeme jen nektere souhrnne informace.
                 * (proto je to tak pomale)
                 * Od toho jsou agregacni funkce, vizte pozdeji na cviceni.
                 */
            }
        } catch (Exception ex) {
            System.err.println("Exception: "+ex);
        }
    }

}
